/*
+-------------------------------------------------------------------+
| PROJECT: MMI-Framework (8445)         $Workfile:: mfw_bt_dg.h				$|
| $Author:: NDH					     $Revision::  1						$|
| CREATED: 17.04.04				     $Modtime:: 17.04.04 10:48			$|
| STATE  : code														 |
+-------------------------------------------------------------------+


   MODULE  : MFW_BT

   PURPOSE : This module contains the definitions for MFW Bluetooth Data Gateway Profile

*/

#ifndef DEF_MFW_BT_DG_HEADER
#define DEF_MFW_BT_DG_HEADER


#include "mfw_bte.h"
#include "bta_dg_api.h"

/*
** The following Macros define the Data Gateway Signals (BT -> Mfw)
*/
#define T_MFW_BT_DG_EVT			tBTA_DG_EVT
#define T_MFW_BT_DG_SIG_DATA		tBTA_DG

/*
** Event Identifiers (Mfw -> BMI)
*/


/*
** Event Parameter Structure Definitions
*/

typedef struct {
	UINT32 dummy;
}T_MFW_BT_DG_DUMMY_SIG;

/*
** Bluetooth Data Gateway Profile Prototypes
*/
void	mfw_bt_dg_cb(T_MFW_BT_DG_EVT event, T_MFW_BT_DG_SIG_DATA *data);
T_MFW_BT_STATUS mfw_bt_dg_hndlr (T_MFW_BT_DG_EVT event, T_MFW_BT_DG_SIG_DATA *data);
T_MFW_BT_STATUS mfw_bt_dg_init( void );
#endif

