#!perl -w
#-------------------------------------------------------------------------------
#  Project :      Nice Delivery System
#  Module  :      nds_update_makefile
#-------------------------------------------------------------------------------
#  Copyright:     2004 Texas Instruments France SA
#                 All rights reserved. 
# 
#                 This file is confidential and a trade secret of Texas 
#                 Instruments.
#                 The receipt of or possession of this file does not convey 
#                 any rights to reproduce or disclose its contents or to 
#                 manufacture, use, or sell anything it may describe, in 
#                 whole, or in part, without the specific written consent of 
#                 Texas Instruments Framce SA. 
#-------------------------------------------------------------------------------
#  Authors :      jr  Joachim Richter
#                 ib  Isabelle Biffi
#-------------------------------------------------------------------------------
#  Versions:      2.0  ib
#-------------------------------------------------------------------------------

# this makefile must be called from \g23m\system
# otherwise most pathes won't work
#
SHELL = sh.exe
BUSYB_INI_FILE = system/unbusy_g23m.ini

$(MFILE):   $(XMLFILE) \
            system/busyb/*.xml \
            system/busyb/sourcesets/*.xml \
            system/busyb/boarddefs/*.xml \
            system/busyb/deliverydefs/*.xml \
            system/busyb/featuredefs/*.xml \
            system/busyb/productdefs/*.xml 
	java "-Xbootclasspath/a:../gpf/tools/lib/java/xercesimpl.jar;../gpf/tools/lib/java/xom.jar" \
	-jar ../gpf/bin/busyb.jar -ini $(BUSYB_INI_FILE) -g -out busyb_tmp1.mak -cfg ./$<
	perl system/busyb/tools/tune_mak_buildconfig.pl busyb_tmp1.mak busyb_tmp2.mak $(XMLFILE)
	perl system/busyb/tools/tune_mak.pl busyb_tmp2.mak $@ dummy
	rm busyb_tmp1.mak
	rm busyb_tmp2.mak
	
