#!/bin/sh
# Something in TI's nasty build mechanism (at least when running under wine)
# messes up the tty modes and fails to restore them upon finish.
# This shell script wraps the needed wine invokation (nowhine actually,
# itself a whine-suppressing wrapper around wine) with some stty magic
# to preserve and restore the tty modes.
#
# Also added the TZ=GMT setting: without it Wine produces additional whines
# about not being able to map my Unix timezone to a Weenie equivalent.

set -x
tty_mode_save=`stty -g`
TZ=GMT nowhine cmd /c build.bat
stty "$tty_mode_save"
